unit gfx_RotateCtrl;
{***********************************************************************
Unit gfx_RotateCtrl.PAS v1.0
    (c) by Andreas Moser, amoser@amoser.de,

    Delphi version : Delphi 4

    gfx_Rotatectrl is part of the gfx_library collection

    You may use this sourcecode for your freewareproducts.
    You may modify this source-code for your own use.
    You may recompile this source-code for your own use.

    All functions, procedures and classes may NOT be used in commercial
    products without the permission of the author. For parts of this library
    which are not written by me, you have to ask for permission by their
    respective authors.


    Disclaimer of warranty: "This software is supplied as is. The author
    disclaims all warranties, expressed or implied, including, without
    limitation, the warranties of merchantability and of fitness for any
    purpose. The author assumes no liability for damages, direct or
    consequential, which may result from the use of this software."

    All brand and product names are marks or registered marks of their
    respective companies.

    Please report bugs to:
    Andreas Moser  amoser@amoser.de

********************************************************************************}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls,gfx_basedef,gfx_Rotresize,gfx_files, Mask, ExtDlgs,io_files,
  Histogram, Spin, Buttons, gfx_colors,vcl_tools;
type
  TRotCtrlForm = class(TForm)
    Label4: TLabel;
    ValueGroup: TRadioGroup;
    DegreeEdit: TEdit;
    Label1: TLabel;
    Bevel1: TBevel;
    EnlCanv: TCheckBox;
    ColorButton: TButton;
    ColorDialog1: TColorDialog;
    Label2: TLabel;
    Label3: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    RotXEdit: TEdit;
    RotYEdit: TEdit;
    PreviewButton: TButton;
    OpenDialog1: TOpenDialog;
    Bevel2: TBevel;
    PreviewImage: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure PreviewButtonClick(Sender: TObject);
    procedure ValueGroupClick(Sender: TObject);
    procedure EnlCanvClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ColorButtonClick(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure CenterEditChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
   private
    ImgTemp:TBitmap;
    { Private-Deklarationen }
  public
    SrcBitmap:TBitmap;
    DestBitmap:TBitmap;
    { Public-Deklarationen }
  end;

var
  RotCtrlForm: TRotCtrlForm;
implementation

{$R *.DFM}

procedure TRotCtrlForm.FormCreate(Sender: TObject);
begin
  SrcBitmap:=tBitmap.Create;
  SrcBitmap.PixelFormat:=pf24Bit;
  DestBitmap:=tBitmap.Create;
  DestBitmap.PixelFormat:=pf24Bit;
  ImgTemp:=TBitmap.Create;
  Imgtemp.PixelFormat:=pf24Bit;
  DegreeEdit.Text:='45';
end;

procedure TRotCtrlForm.FormDestroy(Sender: TObject);
begin
  SrcBitmap.free;
  DestBitmap.Free;
  ImgTemp.Free;
end;

procedure TRotCtrlForm.FormActivate(Sender: TObject);
begin
  if not SrcBitmap.Empty then
  begin
//   PreviewPanel1.SourceBitmap.Assign(SrcPicture.Bitmap);
   StretchResize(SrcBitmap,ImgTemp,100,100,false,clNone,true);
   PreviewImage.Picture.Assign(ImgTemp);
   RotXEdit.Text:=IntToStr(SrcBitmap.Width div 2);
   RotYEdit.Text:=IntToStr(SrcBitmap.Height div 2);
  end;
  DegreeEdit.SetFocus;
  DegreeEdit.OnChange:=Edit1Change;
  RotXEdit.OnChange:=CenterEditChange;
  RotYEdit.OnChange:=CenterEditChange;
end;

procedure TRotCtrlForm.PreviewButtonClick(Sender: TObject);
var ImgTmp2:TBitmap;
begin
  ImgTmp2:=TBitmap.Create;
  ImgTmp2.PixelFormat:=pf24Bit;
  try
  RotateBitmap(ImgTemp,ImgTmp2,StrToInt(DegreeEdit.Text),
  Round(StrToInt(RotXEdit.Text)* (ImgTemp.Width/SrcBitmap.Width)),
  Round(StrToInt(RotYEdit.Text)* (ImgTemp.Height/SrcBitmap.Height)),
  EnlCanv.Checked,
  ColorDialog1.Color,nil);
  if GetDeviceCaps(GetDC(0),BITSPIXEL)=8 then
  begin
//   ApplyPaletteToGraphic( ,PreviewImage.Picture.Bitmap,true,pf8Bit);
   PreviewImage.Picture.Bitmap.Canvas.CopyRect(
   Rect(0,0,Imgtmp2.Width,Imgtmp2.Height),
   Imgtmp2.Canvas,PreviewImage.ClientRect);
   //Rect(0+fPosX,0+fPosY,fOriginalBitmap.Width+fPosX,fOriginalBitmap.Height+fPosY));


  end else PreviewImage.Picture.Assign(ImgTmp2);
  PreviewImage.Repaint;
  finally
  ImgTmp2.Free;
  end;
end;

procedure TRotCtrlForm.ValueGroupClick(Sender: TObject);
begin
case ValueGroup.ItemIndex of
 0:DegreeEdit.Text:='0';
 1:DegreeEdit.Text:='90';
 2:DegreeEdit.Text:='180';
 3:DegreeEdit.Text:='270';
end;
PreviewButtonClick(nil);
end;

procedure TRotCtrlForm.EnlCanvClick(Sender: TObject);
begin
  PreviewButtonClick(nil);
end;

procedure TRotCtrlForm.Button3Click(Sender: TObject);
begin
  Screen.Cursor:=crHourGlass;
  CreateXPanel(Self,200,100);
  XPanel.Caption:='Rotating...';
  try
    if not SrcBitmap.Empty then
    RotateBitmap(SrcBitmap,DestBitmap,StrToInt(DegreeEdit.Text),
    StrToInt(RotXEdit.Text), StrToInt(RotYEdit.Text),
    EnlCanv.Checked,ColorDialog1.Color,XProgress );
  finally
  Screen.Cursor:=crDefault;
  ReleaseXPanel;
  end;
end;

procedure TRotCtrlForm.ColorButtonClick(Sender: TObject);
begin
  ColorDialog1.Execute;
  PreviewButtonClick(nil);
end;

procedure TRotCtrlForm.BitBtn2Click(Sender: TObject);
begin
  Close;
end;

procedure TRotCtrlForm.Edit1Change(Sender: TObject);
begin
  PreviewButtonClick(nil);
end;

procedure TRotCtrlForm.CenterEditChange(Sender: TObject);
begin
  if (Sender as TEdit).Text<>'' then PreviewButtonClick(nil);
end;

procedure TRotCtrlForm.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  DegreeEdit.OnChange:=nil;
  RotXEdit.OnChange:=nil;
  RotYEdit.OnChange:=nil;
end;

end.
